<template>
    <div id="dpnr-production" class="content">
        <!-- Toggle mode modal -->
        <modal-component v-cloak ref="toggleModeModal">
            <template v-slot:header>
                <template v-if="mode === 'auto'">Semi Auto Mode</template>
                <template v-if="mode === 'semi-auto'">Auto Mode</template>
            </template>
            <template v-slot:body>
                <font-awesome-icon icon="exclamation-triangle" class="fa-7x p-2 trip"/>
                <div class="mb-4" v-if="mode === 'auto'">Note: All current running batches will be cancelled!</div>
                <ValidationObserver ref="observer">
                    <ValidationProvider
                        v-slot="{ errors }"
                        name="access code"
                        rules="required"
                    >
                        <div class="row d-flex align-items-center">
                            <div class="col-5">
                                <div class="font-weight-600">Access code</div>
                            </div>
                            <div class="col-7">
                                <input id="access_code" v-model="accessCode" class="form-control" name="access_code"
                                       placeholder="Access code" style="width: 90%" type="password">
                            </div>
                        </div>
                        <div class="row d-flex">
                            <div class="col-12">
                                <div class="ml-4 error-message">{{ errors[0] }}</div>
                            </div>
                        </div>
                    </ValidationProvider>
                </ValidationObserver>
            </template>
            <template v-slot:footer>
                <div class="d-flex justify-content-center align-items-center">
                    <button class="btn btn-blue px-4 py-2" style="width: 10rem" type="button" @click="toggleMode">
                        Start
                    </button>
                    <button class="btn btn-grey ml-4 px-4 py-2" style="width: 10rem" type="button" @click="accessCode = ''; hideModal('toggleModeModal')">
                        Cancel
                    </button>
                </div>
            </template>
        </modal-component>
        <!-- End of toggle mode modal -->

        <!-- Start coagulation and creeping process modal -->
        <modal-component v-cloak ref="startNextProcessModal">
            <template v-slot:header>
                Start Sequence
            </template>
            <template v-slot:body>
                <font-awesome-icon class="warning-icon" icon="exclamation-triangle" style="font-size: 7rem"/>
                <div class="mt-4 font-weight-500" v-if="batch != null">
                    {{
                        batch && batch.operatingMode === "START_PROD"
                        ? 'Start Coagulation & Creeping Process'
                        : 'Start drying'
                    }}
                </div>
            </template>
            <template v-slot:footer>
                <div class="d-flex justify-content-center align-items-center">
                    <button class="btn btn-blue px-4 py-2" style="width: 10rem" type="button" @click="startNextProcess">
                        Start
                    </button>
                    <button class="btn btn-grey ml-4 px-4 py-2" style="width: 10rem" type="button" @click="hideModal('startNextProcessModal')">
                        Cancel
                    </button>
                </div>
            </template>
        </modal-component>
        <!-- End of start coagulation and creeping process modal -->

        <div class="header d-flex justify-content-between align-items-center">
            <h2>DPNR Production</h2>
            <div>
                <button 
                    class="btn btn-blue px-5 font-weight-700" 
                    type="button" 
                    @click="switchProduct()"
                    :disabled="env==='cloud'"
                >
                    <template v-if="enrSwitchStatus===null">-</template>
                    <template v-else-if="enrSwitchStatus">Valve: ENR</template>
                    <template v-else>Valve: DPNR</template>
                </button>
                <button 
                    class="btn btn-blue px-5 font-weight-700 ml-1" 
                    :class="mode === 'auto' ? 'btn-blue' : 'btn-orange'" 
                    type="button" 
                    @click="showModal('toggleModeModal')"
                    :disabled="env==='cloud'"
                >
                    <template v-if="mode === 'auto'">Auto Mode</template>
                    <template v-if="mode === 'semi-auto'">Semi Auto Mode</template>
                </button>
            </div>
        </div>
        <div class="container-fluid">
            <div class="row">
                <!-- Coagulation Starts -->
                <div class="col-4">
                    <div id="coagulation" class="h-100 grow-1 shrink-1 basis-0" style="z-index: 7">
                        <div class="panel h-100">
                            <div class="panel-heading">Coagulation</div>
                            <div class="panel-body">
                                <div :class="setDeviceStatusClass('ETF1', 'on', 'off', 'trip')" class="component text-center font-weight-700 p-3 border">
                                    Fume Extractor <span class="font-weight-normal">ETF1</span></div>
                                <div class="d-flex justify-content-end">
                                    <div>
                                        <div class="d-flex">
                                            <vertical-line-component class="ml-n2" height="3rem"></vertical-line-component>
                                            <vertical-line-component class="ml-5" height="3rem"></vertical-line-component>
                                        </div>
                                        <div class="d-flex">
                                            <pump-component :status="setDeviceIconStatus('FXP1')" class="position-relative ml-5 mt-n3" label-bottom="FXP1">
                                                <horizontal-line-component :arrow-left="true" class="position-absolute" style="top: 13%; left: -72%"
                                                                           width="4rem"></horizontal-line-component>
                                            </pump-component>
                                        </div>
                                    </div>
                                </div>

                                <div class="row mt-4">
                                    <div class="col-6 d-flex justify-content-between">
                                        <pump-component :label-bottom="setDeviceLevel('XCV101_level')" :status="setDeviceIconStatusOtherType('XCV101_status')" class="display-relative" label-top="XCV101" width="4rem">
                                            <horizontal-line-component :arrow-right="true" class="position-absolute ml-3" width="20rem"></horizontal-line-component>
                                        </pump-component>
                                        <div class="d-flex">
                                            <div class="component pr-3">
                                                <div>Latex Tank</div>
                                                <div class="font-weight-normal">LT104</div>
                                                <div>Level</div>
                                                <div class="font-weight-normal">
                                                    {{ setDeviceLevel('LT104') }}
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="mt-5 col-6 pr-2 d-flex justify-content-end">
                                        <div class="mt-3 ml-1 d-flex justify-content-center align-items-center">
                                            <div class="component" style="min-height: 5rem; min-width: 12rem">
                                                <div class="text-center">Acid Tank</div>
                                            </div>
                                        </div>
                                        <horizontal-line-component :arrow-left="true" class="position-relative" style="top: 45%" width="10rem"></horizontal-line-component>

                                        <div class="d-flex justify-content-end position-relative ml-n3">
                                            <pump-component :status="setDeviceIconStatusOtherType('XSV117')" label-top="XSV117" width="4rem"></pump-component>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-5 d-flex justify-content-end">
                                        <vertical-valve-component :label-left="setDeviceLevel('XCV103_valve')" :status="setDeviceIconStatus('XCV103')" label-right="XCV103"></vertical-valve-component>
                                    </div>
                                    <div class="col-5 col-offset-2 d-flex justify-content-start">
                                        <vertical-valve-component :label-left="setDeviceLevel('XCV102_valve')" :status="setDeviceIconStatus('XCV102')" label-right="XCV102" style="margin-left: 9rem"></vertical-valve-component>
                                    </div>
                                </div>

                                <div class="row justify-content-center">
                                    <div class="col-5">
                                        <steam-cogulator-component status="off" style="width: 20rem; margin: 0 auto;"></steam-cogulator-component>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col d-flex justify-content-center">
                                        <vertical-line-component :arrow-down="true" width="2.5rem"></vertical-line-component>
                                    </div>
                                </div>

                                <div class="row justify-content-center">
                                    <div class="col-4 component text-center" style="z-index: 4">
                                        Steam coagulator
                                    </div>
                                </div>

                                <div class="row justify-content-center mt-2">
                                    <div class="col" v-if="latexSeries!=null">
                                        <latex-tank-chart-component :series="latexSeries" />
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <!-- Coagulation End -->

                <!-- Creeping Start -->
                <div class="col-4">
                    <div id="creeping" class="h-100" style="z-index: 6">
                        <div class="panel h-100">
                            <div class="panel-heading">Creeping</div>
                            <div class="panel-body">
                                <div class="component">
                                    <div class="row">
                                        <div class="col-6">
                                            <span>Hopper level</span> <span class="font-weight-normal ml-1">LR201</span>
                                            <div class="position-relative">
                                                <img class="" src="../../../assets/svg/dpnr/coagulation/steam-coagulation-to-laser.svg"
                                                     style="height: 52.5rem; position: absolute; top: -1.7rem; right: 94%; width: 25.5rem;">
                                            </div>
                                        </div>
                                        <div class="font-weight-normal col-6">{{ setDeviceLevel('LR201') }}</div>
                                    </div>
                                </div>

                                <div class="flex-center">
                                    <vertical-line-component :arrow-down="true" class="mr-2"></vertical-line-component>
                                </div>

                                <div class="component">
                                    <div class="row">
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CPR1', 'on', 'off', 'trip')">CPR 1</div>
                                            <div class="d-flex font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CPR1') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CPR1') }}</span>
                                            </div>
                                        </div>
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CVY1', 'on', 'off', 'trip')">CVY 1</div>
                                            <div class="font-weight-normal d-flex">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CVY1') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CVY1') }}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col flex-center">
                                        <vertical-line-component :arrow-down="true"></vertical-line-component>
                                        <circle-component :status="setDeviceIconStatusOtherType('LR202_status')" label-right="LR202"></circle-component>
                                    </div>
                                </div>

                                <div class="component">
                                    <div class="row">
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CPR2', 'on', 'off', 'trip')">CPR 2</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CPR2') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CPR2') }}</span>
                                            </div>
                                        </div>
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CVY2', 'on', 'off', 'trip')">CVY 2</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CVY2') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CVY2') }}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="flex-center">
                                    <vertical-line-component :arrow-down="true"></vertical-line-component>
                                    <circle-component :status="setDeviceIconStatusOtherType('LR203_status')" label-right="LR203"></circle-component>
                                </div>

                                <div class="component">
                                    <div class="row">
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CPR3', 'on', 'off', 'trip')">CPR 3</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CPR3') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CPR3') }}</span>
                                            </div>
                                        </div>
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CVY3', 'on', 'off', 'trip')">CVY 3</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CVY3') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CVY3') }}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="flex-center">
                                    <vertical-line-component :arrow-down="true"></vertical-line-component>
                                    <circle-component :status="setDeviceIconStatusOtherType('LR204_status')" label-right="LR204"></circle-component>
                                </div>

                                <div class="component">
                                    <div class="row">
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CPR4', 'on', 'off', 'trip')">CPR 4</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CPR4') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CPR4') }}</span>
                                            </div>
                                        </div>
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CVY4', 'on', 'off', 'trip')">CVY 4</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CVY4') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CVY4') }}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="flex-center">
                                    <vertical-line-component :arrow-down="true"></vertical-line-component>
                                    <circle-component :status="setDeviceIconStatusOtherType('LR205_status')" label-right="LR205"></circle-component>
                                </div>

                                <div class="component">
                                    <div class="row">
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CPR5', 'on', 'off', 'trip')">CPR 5</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CPR5') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CPR5') }}</span>
                                            </div>
                                        </div>
                                        <div class="col-6">
                                            <div :class="setDeviceStatusClass('CVY5', 'on', 'off', 'trip')">CVY 5</div>
                                            <div class="font-weight-normal">
                                                <span>SPEED</span>
                                                <span class="ml-1">{{ setDeviceInverterPV('CVY5') }}</span>
                                            </div>
                                            <div class="d-flex font-weight-normal">
                                                <span>MODE</span>
                                                <span class="ml-1">{{ setPresetMode('CVY5') }}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="flex-center">
                                    <vertical-line-component :arrow-down="true"></vertical-line-component>
                                    <circle-component :status="setDeviceIconStatusOtherType('LR206_status')" label-right="LR206"></circle-component>
                                </div>

                                <div class="component">
                                    <div class="row">
                                        <div class="col-6">
                                            <span>Shredder</span> <span class="font-weight-normal ml-5">SHR1</span>
                                        </div>
                                        <div class="col-6">
                                            <div>
                                                <span>SPEED</span> <span class="font-weight-normal ml-1">
													{{ setDeviceInverterPV('SHR1') }}
												</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="ml-5">
                                    <vertical-line-component :arrow-down="true"></vertical-line-component>
                                </div>

                                <div class="d-flex align-items-center justify-content-between mt-n3">
                                    <div class="component shrink-1 grow-1 basis-0" style="width: 20rem">
                                        Final though
                                    </div>
                                    <div class="position-relative">
                                        <pump-component :status="setDeviceIconStatus('CBP1')" class="position-relative" label-top="CBP1" style="padding: 0 8rem">
                                            <horizontal-line-component :arrow-right="true" class="position-absolute" style="left: -10%" width="12rem"></horizontal-line-component>
                                            <horizontal-line-component :arrow-right="true" class="position-absolute" style="left: 55%" width="12rem"></horizontal-line-component>
                                        </pump-component>
                                    </div>
                                    <div class="component pr-5">
                                        Filling station
                                        <div class="font-weight-normal">VSFS1</div>
                                        <div>{{ setDeviceStatusText('VSFS1') }}</div>
                                    </div>
                                </div>

                                <div class="d-flex justify-content-end">
                                    <vertical-line-component :arrow-down="true"></vertical-line-component>
                                </div>

                                <div class="d-flex align-items-center justify-content-end position-relative">
                                    <vertical-line-component class="position-absolute" style="top: -79%; left: 6%" height="9rem"></vertical-line-component>

                                    <horizontal-line-component class="position-absolute" style="left: 7%" :arrow-left="true" width="17rem"></horizontal-line-component>

                                    <pump-component class="position-absolute" style="left: 35%" :status="setDeviceIconStatus('BTP1')" label-top="BTP1"></pump-component>

                                    <horizontal-line-component class="position-absolute" style="left: 40%" :arrow-left="true" width="25rem"></horizontal-line-component>

                                    <div class="component">
                                        <div>Return Buffer</div>
                                            <div class="row">
                                                <div class="col-6">
                                                    <div><span class="font-weight-normal">FLS1_R1</span></div>
                                                    <div>{{ setDeviceLevelHighLow('FLS1_R1') }}</div>
                                                </div>
                                                <div class="col-6">
                                                    <div><span class="font-weight-normal">FLS2_R2</span></div>
                                                    <div>{{ setDeviceLevelHighLow('FLS2_R2') }}</div>
                                                </div>
                                        </div>
                                    </div>
                                    
                                </div>

                                <div class="mt-4 d-flex align-items-center justify-content-end position-relative" style="margin-bottom: 3.5rem">
                                    <pump-component class="position-absolute" style="top:0%; left: 35%" :status="setDeviceIconStatus('BTP2')" label-top="BTP2">
                                    </pump-component>

                                    <vertical-line-component class="position-absolute" style="top: -5rem; left: 27%" height="6rem">
                                        <horizontal-line-component class="position-absolute" style="top: 84%; left: 40%" width="5rem"></horizontal-line-component>
                                    </vertical-line-component>

                                    <vertical-line-component class="position-absolute" style="top: -5rem; left: 47%" height="6rem">
                                        <horizontal-line-component class="position-absolute" style="top: 84%; left: -4rem" width="5rem"></horizontal-line-component>
                                    </vertical-line-component>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Creeping End -->

                <div class="col-4">
                    <div class="panel h-100">
                        <div class="panel-heading">
                            <div class="d-flex align-items-center">
                                <div class="mr-4">Controls</div>
                                <button class="py-1 btn" 
                                    :class="!checkObjectEmpty(batch) && (batch.operatingMode === 'START_PROD' || batch.operatingMode === 'COAGULATION') 
                                        ?  'btn-blue' : 'btn-grey'"
                                            style="min-width: 17rem" 
                                        v-if="mode === 'auto'" 
                                        @click="validateCanStartNextProcess"
                                        :disabled="env==='cloud'"
                                    >
                                    {{ 
                                        !checkObjectEmpty(batch) && this.batch.product === "DPNR"
                                        ? batch.operatingMode === 'COAGULATION' 
                                            ? 'COAGULATION & CREEPING' : batch.operatingMode.replace('_', ' ') 
                                        : 'N/A' 
                                    }}
                                </button>
                            </div>
                        </div>
                        <div class="panel-body">
                            <div class="container px-0">
                                <div class="row">
                                    <div class="col-12">
                                        <accordion-component>
                                            <accordion-item-component>
                                                <template slot="header">
                                                    <div class="d-flex align-items-center">
                                                        <h3>Coagulation</h3>
                                                    </div>
                                                </template>
                                                <template slot="content">
                                                    <table>
                                                        <thead>
                                                            <tr class="px-2">
                                                                <th>No.</th>
                                                                <th>Code</th>
                                                                <th class="text-left">Description</th>
                                                                <th>PV</th>
                                                                <th>SV</th>
                                                                <th>Status</th>
                                                            </tr>
                                                        </thead>
                                                        <tbody>
                                                            <tr v-for="(parameter, index) in coagulationParameters" :key="index" :class="{ 'edit-mode': parameter.editMode, 'readonly-mode': !parameter.editMode }" class="px-2">
                                                                <td style="width: 10%">{{ index + 1 }}</td>
                                                                <td style="width: 15%">{{ parameter.code }}</td>
                                                                <td class="text-left" style="width: 30%">
                                                                    {{ parameter.name }}
                                                                </td>
                                                                <td>
                                                                    <!-- On Off type don't have PV and SV -->
                                                                    <div class="d-flex justify-content-center align-items-center" v-if="parameter.type !== 'onOff'">
                                                                        <div>
                                                                            {{ setPVValueForParameter(parameter) }}
                                                                        </div>
                                                                    </div>
                                                                </td>
                                                                <td>
                                                                    <!-- On Off type don't have PV and SV -->
                                                                    <div class="d-flex justify-content-center align-items-center" v-if="parameter.type !== 'onOff'">
                                                                        <div v-if="!parameter.editMode">
                                                                            {{ setSVValueForParameter(parameter) }}
                                                                        </div>
                                                                        <input v-else v-model="coagulationUpdateData[index].sv" type="text">
                                                                    </div>
                                                                </td>
                                                                <td>
                                                                    <template v-if="parameter.type !== 'temp' && parameter.type !== 'valve' && parameter.type !== 'level'">
                                                                        <p-check v-if="parameter.editMode" v-model="coagulationUpdateData[index].status" checked="parameter.status"
                                                                                 class="p-switch p-outline status-toggle"></p-check>

                                                                        <font-awesome-icon v-else :class="setStatusForParameter(parameter)" icon="circle"/>
                                                                    </template>
                                                                </td>
                                                                <td v-if="env!=='cloud'">
                                                                    <template v-if="mode === 'semi-auto' || parameter.type === 'inverter'">
                                                                        <div v-if="!parameter.editMode" class="edit-btn" @click="toggleModeForCoagulationParameters(index)">
                                                                            <font-awesome-icon icon="pencil-alt"/>
                                                                        </div>

                                                                        <div v-if="parameter.editMode" class="d-flex">
                                                                            <div class="save-btn mr-2" @click="saveCoagulationParameter(parameter, index)">
                                                                                <font-awesome-icon icon="save"/>
                                                                            </div>
                                                                            <div class="cancel-btn" @click="toggleModeForCoagulationParameters(index)">
                                                                                <font-awesome-icon icon="window-close"/>
                                                                            </div>
                                                                        </div>
                                                                    </template>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </template>
                                            </accordion-item-component>

                                            <accordion-item-component>
                                                <template slot="header">
                                                    <div class="d-flex align-items-center">
                                                        <h3>Creeping</h3>
                                                    </div>
                                                </template>
                                                <template slot="content">
                                                    <table>
                                                        <thead>
                                                            <tr class="px-2">
                                                                <th>No.</th>
                                                                <th>Code</th>
                                                                <th class="text-left">Description</th>
                                                                <th>Base</th>
                                                                <th>PV</th>
                                                                <th>SV</th>
                                                                <th>Status</th>
                                                            </tr>
                                                        </thead>
                                                        <tbody>
                                                            <tr v-for="(parameter, index) in creepingParameters" :key="index" :class="{ 'edit-mode': parameter.editMode, 'readonly-mode': !parameter.editMode }" class="px-2">
                                                                <td style="width: 10%">{{ index + 1 }}</td>
                                                                <td style="width: 15%">{{ parameter.code }}</td>
                                                                <td class="text-left" style="width: 30%">
                                                                    {{ parameter.name }}
                                                                </td>
                                                                <td class="text-left" style="width: 30%">
                                                                    <div v-if="parameter.type==='inverter'">
                                                                        {{ setPresetValue(parameter.code) }} {{parameter.unit}}
                                                                    </div>
                                                                </td>
                                                                <td>
                                                                    <!-- On Off type don't have PV and SV -->
                                                                    <div class="d-flex justify-content-center align-items-center" v-if="parameter.type !== 'onOff'">
                                                                        <div>
                                                                            {{ setPVValueForParameter(parameter) }}
                                                                        </div>
                                                                    </div>
                                                                </td>
                                                                <td>
                                                                    <!-- On Off type don't have PV and SV -->
                                                                    <div class="d-flex justify-content-center align-items-center" v-if="parameter.type !== 'onOff'">
                                                                        <div v-if="!parameter.editMode">
                                                                            {{ setSVValueForParameter(parameter) }}
                                                                        </div>
                                                                        <input v-else v-model="creepingUpdateData[index].sv" type="text">
                                                                    </div>
                                                                </td>
                                                                <td>
                                                                    <template v-if="parameter.type !== 'temp' && parameter.type !== 'level'">
                                                                        <p-check v-if="parameter.editMode" v-model="creepingUpdateData[index].status" checked="parameter.status"
                                                                                 class="p-switch p-outline status-toggle"></p-check>

                                                                        <font-awesome-icon v-else :class="setStatusForParameter(parameter)" icon="circle"/>
                                                                    </template>
                                                                </td>
                                                                <td v-if="env!=='cloud'">
                                                                    <template v-if="mode === 'semi-auto' || parameter.type === 'inverter'">
                                                                        <div v-if="!parameter.editMode" class="edit-btn" @click="toggleModeForCreepingParameters(index)">
                                                                            <font-awesome-icon icon="pencil-alt"/>
                                                                        </div>

                                                                        <div v-if="parameter.editMode" class="d-flex">
                                                                            <div class="save-btn mr-2" @click="saveCreepingParameter(parameter, index)">
                                                                                <font-awesome-icon icon="save"/>
                                                                            </div>
                                                                            <div class="cancel-btn" @click="toggleModeForCreepingParameters(index)">
                                                                                <font-awesome-icon icon="window-close"/>
                                                                            </div>
                                                                        </div>
                                                                    </template>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </template>
                                            </accordion-item-component>
                                        </accordion-component>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import PumpComponent from '../../../components/productions/Pump'
import VerticalValveComponent from "../../../components/productions/VerticalValve";
import HorizontalLineComponent from "../../../components/productions/HorizontalLine";
import LatexTankChartComponent from './LatexTankChart'
import SteamCoagulatorComponent from '../../../components/productions/SteamCoagulator'
import VerticalLineComponent from "../../../components/productions/VerticalLine";
import CircleComponent from "../../../components/productions/Circle";
import AccordionComponent from '../../../components/accordion/Accordion'
import AccordionItemComponent from '../../../components/accordion/AccordionItem'
import {topics} from "@/utils/mqtt-topics";
import parameterMixin from "../../../mixins/parameter";
import helperMixin from "@/mixins/helper";
import deviceMixin from "../../../mixins/device";
import persetMixin from "../../../mixins/preset";
import timeMixin from "../../../mixins/time";
import ModalComponent from '../../../components/modal/Modal';
import ControlService from "@/services/ControlService";
import {mapFields} from "vuex-map-fields";
import AutomationService from "@/services/AutomationService";
import VolumeService from "@/services/VolumeService";
import ValveService from "@/services/ValveService";
import { CHART_INTERVAL } from "@/utils/constant";

let parameters = require('../../../assets/data/parameters.json');

export default {
    name: "dpnr-production-component",
    mixins: [
        deviceMixin,
        parameterMixin,
        helperMixin,
        persetMixin,
        timeMixin
    ],
    components: {
        'vertical-valve-component': VerticalValveComponent,
        'pump-component': PumpComponent,
        'horizontal-line-component': HorizontalLineComponent,
        'latex-tank-chart-component': LatexTankChartComponent,
        'steam-cogulator-component': SteamCoagulatorComponent,
        'vertical-line-component': VerticalLineComponent,
        'circle-component': CircleComponent,
        'accordion-component': AccordionComponent,
        'accordion-item-component': AccordionItemComponent,
        'modal-component': ModalComponent,
    },
    data: function () {
        return {
            env: process.env.VUE_APP_ENV,
            accessCode: '',
            coagulationParameters: [],
            coagulationUpdateData: [],
            creepingParameters: [],
            creepingUpdateData: [],
            device: {},
            preset: {},
            topics: topics.dpnrProductionPage,
            batch: null,
            latexSeries: null,
            enrSwitchStatus: null
        }
    },
    methods: {
        /**
         * Toggle mode between auto and semi auto.
         */
        async toggleMode() {
            this.showLoadingOverlay();

            let validationPassed = await this.$refs.observer.validate();

            if (!validationPassed) {
                this.hideLoadingOverlay();
                return;
            }

            let userID = JSON.parse(window.localStorage.getItem('user')).id;
            let vm = this;
            let newMode = this.mode === 'auto' ? false : true;

            // Request API to change automation mode.
            // If current mode is auto change to semi auto.
            // If current mode is semi auto change to auto.
            this.controlService.changeAutomationMode(this.accessCode, newMode, userID).then((result) => {
                if (typeof result.response !== 'undefined') {
                    vm.hideModal('toggleModeModal');

                    vm.$swal({
                        title: "Error!",
                        text: result.response.data.message,
                        icon: "error",
                        confirmButtonText: "OK"
                    }).then(() => {
                        vm.showModal('toggleModeModal');
                    });

                    vm.accessCode = '';
                    vm.hideLoadingOverlay();
                } else {
                    vm.hideLoadingOverlay();
                    vm.hideModal('toggleModeModal');

                    vm.mode = newMode ? 'auto' : 'semi-auto';
                    vm.accessCode = '';

                    vm.$swal({
                        title: "Success!",
                        text: result.data.message,
                        icon: "success",
                        confirmButtonText: "OK"
                    });
                }
            })
        },

        /**
         * Get all parameter for coagulation and creeping from the parameters.json file.
         *
         * @returns {Promise<void>}
         */
        getParameters: async function () {
            // Get coagulation parameters.
            this.coagulationParameters = parameters.dpnr.coagulation;
            this.coagulationParameters.forEach((parameter , index)=> {
                this.subscribeMQTTTopicDynamically(parameter);

                this.$set(parameter, 'editMode', false);

                this.setDeviceData(parameter);
            });

            // Get creeping parameters.
            this.creepingParameters = parameters.dpnr.creeping;
            this.creepingParameters.forEach(parameter => {
                this.subscribeMQTTTopicDynamically(parameter);

                this.$set(parameter, 'editMode', false);

                this.setDeviceData(parameter);
            });
        },

        /**
         * Set device data.
         * Only for parameters like mixing, creeping, coagulation, cooling, heating.
         *
         * Need to set device data because if the topic not exist or not return the data,
         * you still can update the parameter.
         */
        setDeviceData(parameter) {
            // Set device data for parameter with inverter type.
            // Set device preset data for parameter with inverter type. Only for DPNR production
            if (parameter.type === 'inverter') {
                // The data must same with the data received from MQTT topic.
                // Example topic: lgm/device/FAS1
                let device = {
                    "isOn": false,
                    "isTripped": false,
                    "isAuto": false,
                    "opHz": null,
                    "refHz": null,
                    "device_id": parameter.code
                }
                let preset = {
                    "mode": null,
                    "value": null,
                }

                this.$set(this.device, parameter.code, device)
                this.$set(this.preset, parameter.code, preset)
            }

            // Set device data for parameter with onOff type.
            if (parameter.type === 'onOff') {
                // The data must same with the data received from MQTT topic.
                // Example topic: lgm/device/CCWP1
                let device = {
                    "isOn": false,
                    "isTripped": false,
                    "isAuto": false,
                    "device_id": parameter.code
                }

                this.$set(this.device, parameter.code, device)
            }

            // Set device data for parameter with PID type.
            // Why need to set device data 2 times.
            // It because for parameter with PID type, you need to listen 2 MQTT topics.
            if (parameter.type === 'pid') {
                // The data must same with the data received from MQTT topic.
                // Example topic: lgm/device/CCWP1
                let device = {
                    "isOn": false,
                    "isTripped": false,
                    "isAuto": false,
                    "device_id": parameter.code
                }

                this.$set(this.device, parameter.code, device)

                // The data must same with the data received from MQTT topic.
                // Example topic: lgm/data/LT101/level
                device = {
                    "timestamp": null,
                    "value": null,
                    "sv": null,
                    "mv": null,
                    "status": 1,
                    "type": "level",
                    "device_id": parameter.code
                }

                this.$set(this.device, parameter.code + '_level', device)
            }

            if (parameter.type === 'valve') {
                // The data must same with the data received from MQTT topic.
                // Example topic: lgm/data/XCV102/valve
                let device = {
                    "timestamp": null,
                    "value": null,
                    "sv": null,
                    "mv": null,
                    "device_id": parameter.code
                }

                this.$set(this.device, parameter.code, device)
            }

            // Set device data for parameter with temp type.
            if (parameter.type === 'temp') {
                // The data must same with the data received from MQTT topic.
                // Example topic: lgm/data/TT106/temp
                let device = {
                        "timestamp": null,
                        "value": null,
                        "sv": null,
                        "mv": null,
                        "status": 1,
                        "type": "temp",
                        "device_id": parameter.code
                }

                this.$set(this.device, parameter.code + '_temp', device) 
            }
        },

        /**
         * Subscribe MQTT Topic dynamically for control parameters.
         */
        subscribeMQTTTopicDynamically(parameter) {
            // Topic for device status.
            // Every device got this topic. Doesn't matter the parameter type whether inverter, temp, onOff or PID.
            // Example topic: lgm/device/FAS1
            let topic = ['lgm/device/' + parameter.code];

            // For parameter with PID type, need to subscribe additional topic to get the level data.
            if (parameter.type === 'pid') {
                topic.push('lgm/data/' + parameter.code + '/level');
            }

            // For parameter with temp type, need to subscribe additional topic to get the temperature data.
            if (parameter.type === 'temp') {
                topic.push('lgm/data/' + parameter.code + '/temp');
            }

            // For parameter with valve type, need to subscribe additional topic to get the temperature data.
            if (parameter.type === 'valve') {
                topic.push('lgm/data/' + parameter.code + '/valve');
            }

            if (parameter.type === 'level') {
                topic.push('lgm/data/' + parameter.code + '/level');
            }

            this.$mqtt.subscribe(topic, function (err, granted) {
                if (err) {
                    console.log("DPNR Preparations - Error During Subscription For Topic " + topic);
                }
                if (granted !== undefined) {
                    granted.forEach(function (grant) {
                        console.log("DPNR Preparations - Subscribed to topic " + grant.topic);
                    })
                }
            });
        },

        /**
         * Toggle mode between read only and edit mode for coagulation parameters.
         *
         * @param index
         */
        toggleModeForCoagulationParameters(index) {
            // Empty the coagulation update data.
            this.coagulationUpdateData = [];

            // Check if the index is exist in coagulation parameters.
            if (typeof this.coagulationParameters[index] === 'undefined') {
                return;
            }

            // This function used to change other parameter mode to read only.
            // Let say you 3 parameters. Parameter A, Parameter B and Parameter C.
            // When you edit Paramter A, Parameter B and C mode will change to read only.
            this.coagulationParameters.map(function (parameter, index1) {
                if (index != index1) {
                    parameter.editMode = false;
                    return parameter
                }
            });

            // Get the parameter data based on the index.
            let parameter = this.coagulationParameters[index];

            // If current mode is edit mode, change to read only mode.
            if (this.coagulationParameters[index].editMode === true) {
                parameter.editMode = false;

                // If current mode is read only mode, change to edit mode.
            } else {
                parameter.editMode = true;

                let status = false;

                // Set the status based on the 'isOn' & 'isTripped attribute.
                // The status either on or off.
                // For parameter with temp type, no need to display status.
                if (parameter.type !== 'temp') {
                    if (this.device[parameter.code].isTripped) {
                        status = false;
                    }

                    if (this.device[parameter.code].isOn) {
                        status = true;
                    }
                }

                // Set initial update data for parameter with type inverter.
                // For inverter you can update both (SV and status).
                if (parameter.type === 'inverter') {
                    this.coagulationUpdateData[index] = {
                        "code": this.coagulationParameters[index].code,
                        'sv': this.device[parameter.code].refHz,
                        'status': status,
                    };
                }

                // Set initial update data for parameter with type PID.
                // For PID type you can update both (SV and status).
                if (parameter.type === 'pid') {
                    this.coagulationUpdateData[index] = {
                        "code": this.coagulationParameters[index].code,
                        'sv': this.device[parameter.code + '_level'].sv,
                        'status': status,
                    };
                }

                // Set initial update data for parameter with type valve.
                // For valve type you can update SV only.
                if (parameter.type === 'valve') {
                    this.coagulationUpdateData[index] = {
                        "code": this.coagulationParameters[index].code,
                        'sv': this.device[parameter.code ].value,
                    };
                }

                // Set initial update data for parameter with type level.
                // For level type you can update SV only.
                if (parameter.type === 'level') {
                    this.coagulationUpdateData[index] = {
                        "code": this.coagulationParameters[index].code,
                        'sv': this.device[parameter.code ].value,
                    };
                }

                // Set initial update data for parameter with type onOff.
                // For onOff type you only can update status.
                if (parameter.type === 'onOff') {
                    this.coagulationUpdateData[index] = {
                        "code": this.coagulationParameters[index].code,
                        'status': status,
                    };
                }

                // Set initial update data for parameter with type temp.
                // For temp type you only can update SV.
                // Special case for TT102 until TT105 where you can update operating mode.
                if (parameter.type === 'temp') {
                    if (parameter.code === 'TT102' || parameter.code === 'TT103' || parameter.code === 'TT104' || parameter.code === 'TT105') {
                        this.coagulationUpdateData[index] = {
                            "code": this.coagulationParameters[index].code,
                            'sv': this.device[parameter.code + '_temp'].sv,
                            'operatingMode': this.device[parameter.code + '_temp'].operatingMode,
                        };
                    } else {
                        this.coagulationUpdateData[index] = {
                            "code": this.coagulationParameters[index].code,
                            'sv': this.device[parameter.code + '_temp'].sv,
                        };
                    }
                }
            }

            this.$set(this.coagulationParameters, index, parameter);
        },

        /**
         * Save updated data for coagulation parameter.
         *
         * @param parameter
         */
        async saveCoagulationParameter(parameter, index) {
            // Clear the error message and set validation fail to false.
            let validationFailed = false;
            let errorMessage = '';

            console.log(parameter)

            // Only check validation for parameter type inverter,pid,temp, valve
            // because for parameter with onOff type don't have SV.
            if (parameter.type !== 'onOff') {
                // Empty validation for SV.
                if (!this.coagulationUpdateData[index].sv) {
                    validationFailed = true;
                    errorMessage = 'SV value is required'
                }

                // Integer validation for SV.
                if (Number(this.coagulationUpdateData[index].sv) != this.coagulationUpdateData[index].sv || this.coagulationUpdateData[index].sv % 1 !== 0) {
                    validationFailed = true;
                    errorMessage = 'SV value must be a number.'
                }

                // Validate range value for inverter.
                // For inverter the range is between 0 and 50.
                if (parameter.type === 'inverter' && (this.coagulationUpdateData[index].sv > 50 || this.coagulationUpdateData[index].sv < 0)) {
                    validationFailed = true;
                    errorMessage = 'Allowed range for inverter SV value is between 0 and 50.'
                }

                // Validate range value for pid.
                // For PID the range is between 0 and 100.
                if (parameter.type === 'pid' && (this.coagulationUpdateData[index].sv > 100 || this.coagulationUpdateData[index].sv < 0)) {
                    validationFailed = true;
                    errorMessage = 'Allowed range for pid SV value is between 0 and 100.'
                }

                // Validate range value for valve.
                // For valve the range is between 0 and 100.
                if (parameter.type === 'valve' && (this.coagulationUpdateData[index].sv > 100 || this.coagulationUpdateData[index].sv < 0)) {
                    validationFailed = true;
                    errorMessage = 'Allowed range for valve SV value is between 0 and 100.'
                }

                // If validation failed show an error message in popup.
                if (validationFailed) {
                    this.$swal({
                        title: "Error!",
                        text: errorMessage,
                        icon: "error",
                        confirmButtonText: "OK"
                    });

                    return;
                }
            }

            this.showLoadingOverlay();

            // Need to check the parameter type because the API need request to update the data is different.
            if (this.coagulationParameters[index].type === 'inverter') {
                let result = await this.controlService.setDeviceState(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].status);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                result = await this.controlService.setInverterHz(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code].refHz = this.coagulationUpdateData[index].sv;
            }

            if (this.coagulationParameters[index].type === 'onOff') {
                let result = await this.controlService.setDeviceState(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].status);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }
            }

            if (this.coagulationParameters[index].type === 'pid') {
                let result = await this.controlService.setDeviceState(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].status);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                result = await this.controlService.setDeviceValue(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code + '_level'].sv = this.coagulationUpdateData[index].sv;
            }

             if (this.coagulationParameters[index].type === 'valve') {
                let result = await this.controlService.setModulatingValue(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code].sv = this.coagulationUpdateData[index].sv;
            }

            if (this.coagulationParameters[index].type === 'level') {
                let result = await this.controlService.setDeviceValue(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code].sv = this.coagulationUpdateData[index].sv;
            }

            if (this.coagulationParameters[index].type === 'temp') {
                if (parameter.code === 'TT102' || parameter.code === 'TT103' || parameter.code === 'TT104' || parameter.code === 'TT105') {
                    let result = await this.controlService.changeDeviceMode(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].status);

                    if (typeof result.response !== 'undefined') {
                        this.displayErrorPopup(result);
                        return;
                    }
                }

                let result = await this.controlService.setDeviceValue(this.coagulationUpdateData[index].code, this.coagulationUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code + '_temp'].sv = this.coagulationUpdateData[index].sv;
                this.device[parameter.code + '_temp'].mode = this.coagulationUpdateData[index].mode;
            }

            // Update device status based on status update value.
            // For parameter with type temp don't have status.
            // No need to update for temp.
            let statusObjectKey = parameter.code;

            if (parameter.type !== 'temp' && parameter.type !== 'valve' && parameter.type !== 'level') {
                this.device[statusObjectKey].isTripped = false;

                if (this.coagulationUpdateData[index].status) {
                    this.device[statusObjectKey].isOn = true
                } else {
                    this.device[statusObjectKey].isOn = false;
                }
            }

            // Disable edit mode.
            this.coagulationParameters[index].editMode = false;

            this.$swal({
                title: "Success",
                html: "<div>Successfully updated the coagulation parameter " + this.coagulationUpdateData[index].code + ".</div>",
                icon: "success",
                confirmButtonText: "OK"
            });

            // Remove update data after successfully save.
            this.coagulationUpdateData.splice(index, 1);
            console.log(this.device)

            this.hideLoadingOverlay();
        },

        /**
         * Toggle mode between read only and edit mode for creeping parameters.
         *
         * @param index
         */
        toggleModeForCreepingParameters(index) {
            // Empty the creeping update data.
            this.creepingUpdateData = [];

            // Check if the index is exist in creeping parameters.
            if (typeof this.creepingParameters[index] === 'undefined') {
                return;
            }

            // This function used to change other parameter mode to read only.
            // Let say you 3 parameters. Parameter A, Parameter B and Parameter C.
            // When you edit Paramter A, Parameter B and C mode will change to read only.
            this.creepingParameters.map(function (parameter, index1) {
                if (index != index1) {
                    parameter.editMode = false;
                    return parameter
                }
            });

            // Get the parameter data based on the index.
            let parameter = this.creepingParameters[index];

            // If current mode is edit mode, change to read only mode.
            if (this.creepingParameters[index].editMode === true) {
                parameter.editMode = false;

                // If current mode is read only mode, change to edit mode.
            } else {
                parameter.editMode = true;

                let status = false;

                // Set the status based on the 'isOn' & 'isTripped attribute.
                // The status either on or off.
                // For parameter with temp type, no need to display status.
                if (parameter.type !== 'temp') {
                    if (this.device[parameter.code].isTripped) {
                        status = false;
                    }

                    if (this.device[parameter.code].isOn) {
                        status = true;
                    }
                }

                // Set initial update data for parameter with type inverter.
                // For inverter you can update both (SV and status).
                if (parameter.type === 'inverter') {
                    this.creepingUpdateData[index] = {
                        "code": this.creepingParameters[index].code,
                        'sv': this.device[parameter.code].refHz,
                        'status': status,
                    };
                }

                // Set initial update data for parameter with type PID.
                // For PID type you can update both (SV and status).
                if (parameter.type === 'pid') {
                    this.creepingUpdateData[index] = {
                        "code": this.creepingParameters[index].code,
                        'sv': this.device[parameter.code + '_level'].sv,
                        'status': status,
                    };
                }

                // Set initial update data for parameter with type level.
                // For level type you can update SV only.
                if (parameter.type === 'level') {
                    this.coagulationUpdateData[index] = {
                        "code": this.coagulationParameters[index].code,
                        'sv': this.device[parameter.code ].value,
                    };
                }

                // Set initial update data for parameter with type onOff.
                // For onOff type you only can update status.
                if (parameter.type === 'onOff') {
                    this.creepingUpdateData[index] = {
                        "code": this.creepingParameters[index].code,
                        'status': status,
                    };
                }

                // Set initial update data for parameter with type temp.
                // For temp type you only can update SV.
                // Special case for TT102 until TT105 where you can update operating mode.
                if (parameter.type === 'temp') {
                    if (parameter.code === 'TT102' || parameter.code === 'TT103' || parameter.code === 'TT104' || parameter.code === 'TT105') {
                        this.creepingUpdateData[index] = {
                            "code": this.creepingParameters[index].code,
                            'sv': this.device[parameter.code + '_temp'].sv,
                            'operatingMode': this.device[parameter.code + '_temp'].operatingMode,
                        };
                    } else {
                        this.creepingUpdateData[index] = {
                            "code": this.creepingParameters[index].code,
                            'sv': this.device[parameter.code + '_temp'].sv,
                        };
                    }
                }
            }

            this.$set(this.creepingParameters, index, parameter);
        },

        /**
         * Save updated data for creeping parameter.
         *
         * @param parameter
         */
        async saveCreepingParameter(parameter, index) {
            // Clear the error message and set validation fail to false.
            let validationFailed = false;
            let errorMessage = '';

            // Only check validation for parameter type inverter,pid,temp
            // because for parameter with onOff type don't have SV.
            if (parameter.type !== 'onOff') {
                // Empty validation for SV.
                if (!this.creepingUpdateData[index].sv) {
                    validationFailed = true;
                    errorMessage = 'SV value is required'
                }

                // Integer validation for SV.
                if (Number(this.creepingUpdateData[index].sv) != this.creepingUpdateData[index].sv || this.creepingUpdateData[index].sv % 1 !== 0) {
                    validationFailed = true;
                    errorMessage = 'SV value must be a number.'
                }

                // Validate range value for inverter.
                // For inverter the range is between 0 and 50.
                if (parameter.type === 'inverter') {
                    if (this.mode !== 'auto' && (this.creepingUpdateData[index].sv > 50 || this.creepingUpdateData[index].sv < 0)) {
                        validationFailed = true;
                        errorMessage = 'Allowed range for inverter SV value is between 0 and 50.'
                    } else {
                        let offsetValue = this.setPresetValue(parameter.code)
                        let different = Math.abs(this.creepingUpdateData[index].sv - offsetValue);
                        if(different > 5 || (this.creepingUpdateData[index].sv > 50 || this.creepingUpdateData[index].sv < 0)) {
                            validationFailed = true;
                            errorMessage = 'Exceed allowed range for inverter SV value on auto mode.'
                        }
                    }
                }
                

                // Validate range value for pid.
                // For PID the range is between 0 and 100.
                if (parameter.type === 'pid' && (this.creepingUpdateData[index].sv > 100 || this.creepingUpdateData[index].sv < 0)) {
                    validationFailed = true;
                    errorMessage = 'Allowed range for pid SV value is between 0 and 100.'
                }

                // If validation failed show an error message in popup.
                if (validationFailed) {
                    this.$swal({
                        title: "Error!",
                        text: errorMessage,
                        icon: "error",
                        confirmButtonText: "OK"
                    });

                    return;
                }
            }

            this.showLoadingOverlay();

            // Need to check the parameter type because the API need request to update the data is different for each type.
            if (this.creepingParameters[index].type === 'inverter') {
                let result = await this.controlService.setDeviceState(this.creepingUpdateData[index].code, this.creepingUpdateData[index].status);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                result = await this.controlService.setInverterHz(this.creepingUpdateData[index].code, this.creepingUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code].refHz = this.creepingUpdateData[index].sv;
            }

            if (this.creepingParameters[index].type === 'onOff') {
                let result = await this.controlService.setDeviceState(this.creepingUpdateData[index].code, this.creepingUpdateData[index].status);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }
            }

            if (this.creepingParameters[index].type === 'pid') {
                let result = await this.controlService.setDeviceState(this.creepingUpdateData[index].code, this.creepingUpdateData[index].status);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                result = await this.controlService.setDeviceValue(this.creepingUpdateData[index].code, this.creepingUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code + '_level'].sv = this.creepingUpdateData[index].sv;
            }

            if (this.creepingParameters[index].type === 'temp') {
                if (parameter.code === 'TT102' || parameter.code === 'TT103' || parameter.code === 'TT104' || parameter.code === 'TT105') {
                    let result = await this.controlService.changeDeviceMode(this.creepingUpdateData[index].code, this.creepingUpdateData[index].status);

                    if (typeof result.response !== 'undefined') {
                        this.displayErrorPopup(result);
                        return;
                    }
                }

                let result = await this.controlService.setDeviceValue(this.creepingUpdateData[index].code, this.creepingUpdateData[index].sv);

                if (typeof result.response !== 'undefined') {
                    this.displayErrorPopup(result);
                    return;
                }

                this.device[parameter.code + '_temp'].sv = this.creepingUpdateData[index].sv;
                this.device[parameter.code + '_temp'].mode = this.creepingUpdateData[index].mode;
            }

            // Update device status based on status update value.
            // For parameter with type temp don't have status.
            // No need to update for temp.
            let statusObjectKey = parameter.code;

            if (parameter.type !== 'temp') {
                this.device[statusObjectKey].isTripped = false;

                if (this.creepingUpdateData[index].status) {
                    this.device[statusObjectKey].isOn = true
                } else {
                    this.device[statusObjectKey].isOn = false;
                }
            }

            // Disable edit mode.
            this.creepingParameters[index].editMode = false;

            this.$swal({
                title: "Success",
                html: "<div>Successfully updated the creeping parameter " + this.creepingUpdateData[index].code + ".</div>",
                icon: "success",
                confirmButtonText: "OK"
            });

            // Remove update data after successfully save.
            this.creepingUpdateData.splice(index, 1);

            this.hideLoadingOverlay();
        },


        /**
         * Validate coagulation and soaking process can start or not. Must start DPNR process first (Step 1).
         * And then soaking status is false in DPNR Production batch data.
         * The batch data get from Vuex.
         */
        validateCanStartNextProcess() {
            // Check if DPNR process already start.
            // If not start, show an error message in popup.
            if (this.prod.productId !== 'DPNR' && !this.prod.isActive) {
                this.$swal({
                    title: "Error",
                    html: `You must start DPNR production process first before you can start the coagulation and creeping process.`,
                    icon: "error",
                    confirmButtonText: "OK"
                });
                return;
            }

            if (this.checkObjectEmpty(this.batch) || this.batch.product !== 'DPNR') {
                return;
            }

            if(this.batch.operatingMode !== 'START_PROD' && this.batch.operatingMode !== 'COAGULATION' ) {
                return;
            }

            // if (this.nextProcess === 'COAGULATION') {
            //     return;
            // }

            this.showModal('startNextProcessModal')
        },

        /**
         * Start coagulation and creeping process simultaneously by calling next batch process API.
         */
        async startNextProcess() {
            this.hideModal('startNextProcessModal');

            this.showLoadingOverlay();

            let nextProcess = this.nextProcess.substr(0, 1).toUpperCase() + this.nextProcess.substr(1).toLowerCase();
            // hardcoded mapping for display purpose
            if (nextProcess==="Wait_drying" || nextProcess==="Wait_dryer") {
                nextProcess= "Start drying"                
            }

            let result = await this.controlService.startNextBatchProcess('prod');

            if (typeof result.response !== 'undefined') {
                this.displayErrorPopup(result);
                return;
            }

            this.hideLoadingOverlay();

            this.$swal({
                title: "Success",
                html: "Successfully start DPNR production " + nextProcess.replace('_',' ') + " process.",
                icon: "success",
                confirmButtonText: "OK"
            });
        },

        /**
         *  Get next process.
         */
        getNextProcess(message) {
            if (this.checkObjectEmpty(message)) {
                this.nextProcess = 'N/A';
            }
            if (message.operatingMode === 'START_PROD') {
                this.nextProcess = 'COAGULATION';
                return;
            }

            if (message.operatingMode === 'COAGULATION') {
                this.nextProcess = 'WAIT_DRYER';
                return;
            }

            this.nextProcess = 'N/A';
        },

        /**
         *  Get latex tank volume chart
         */
        async getLatexChart() {
            let nowTimestamp = new Date().getTime()
            let start = this.get12AMTimestamp(nowTimestamp);
            let lt104 = await this.volumeService.getVolumeByDevice('LT104', start, nowTimestamp, CHART_INTERVAL)
            let xcv102 = await this.valveService.getDeviceOpeningValve('XCV102', start, nowTimestamp, CHART_INTERVAL)
            let xcv103 = await this.valveService.getDeviceOpeningValve('XCV103', start, nowTimestamp, CHART_INTERVAL)

            let latexSeries = {
                xAxis: [],
                yAxis: [
                    {
                    type: 'column',
                    name: 'Latex',
                    color: '#8B572A'
                    },
                    {
                    name: 'XCV102',
                    color: '#03A9F4'
                    },
                    {
                    name: 'XCV103',
                    color: '#009688'
                    }
                ]
            }

            latexSeries.yAxis[0].data = lt104.data.data.map((item) => { return item.volume });
            latexSeries.yAxis[1].data = xcv102.data.data.map((item) => { return item.opening });
            latexSeries.yAxis[2].data = xcv103.data.data.map((item) => { return item.opening });
            latexSeries.xAxis = lt104.data.data.map((item) => {
                return this.timestampToTime(item.timestamp);
            });

            this.latexSeries = latexSeries
        },

        /**
         *  Ctrl LT104, LT105 to switch between ENR/DPNR
         */
        async switchProduct() {
            this.showLoadingOverlay()
            let result = await this.controlService.setDeviceState('ENR_DPNR', this.enrSwitchStatus ? 'off' : 'on' );
            if (typeof result.response !== 'undefined') {
                this.displayErrorPopup(result);
                return;
            }
            this.enrSwitchStatus = !this.enrSwitchStatus
            this.hideLoadingOverlay()
        }
    },
    computed: {
        /**
         * The `mapFields` function takes an array of field names and generates corresponding
         * computed properties with getter and setter functions for accessing the Vuex store.
         */
        ...mapFields([
            'mode',
            'prod',
        ]),

        /**
         * Create ControlService instance.
         *
         * @returns {ControlService}
         */
        controlService: function () {
            return new ControlService();
        },

        /**
         * Create AutomationService instance.
         *
         * @returns {AutomationService}
         */
        automationService: function () {
            return new AutomationService();
        },

        /**
         * Create VolumeService instance.
         *
         * @returns {VolumeService}
         */
        volumeService: function () {
            return new VolumeService();
        },

        valveService: function() {
            return new ValveService();
        }
    },
    mqtt: {
        /**
         * Listen for preset status.
         */
        'lgm/preset/+'(message, topic) {
            // console.log("\nDPNR Productions - Received message from " + topic + " topic at " 
            //     + new Date().toLocaleString() + "\n" + message.toString())

            message = JSON.parse(message.toString());

            this.$set(this.preset, message.deviceId, message);
        },

        /**
         * Listen for device status.
         * If the device is inverter, it contains PV and SV.
         */
        'lgm/device/+'(message, topic) {
            // console.log("\nDPNR Productions - Received message from " + topic + " topic at " + new Date().toLocaleString())
            // console.log("DPNR Productions - The message was " + message.toString());

            message = JSON.parse(message.toString());

            this.$set(this.device, message.device_id, message);
        },

        /**
         * Listen for specific device data.
         * For example device temperature, level and PID.
         */
        'lgm/data/+/+'(message, topic) {
            if (topic === 'lgm/data/autoMode/status' || topic === 'lgm/data/ENR_DPNR/status') {
                return;
            }

            // console.log("\nDPNR Productions - Received message from " + topic + " topic at " + new Date().toLocaleString()
            //     + "\n" + message.toString())

            message = JSON.parse(message.toString());

            this.$set(this.device, message.device_id, message);
        },

        /**
         * Listen for running mode whether semi auto mode or auto mode.
         */
        'lgm/data/autoMode/status'(message, topic) {
            // console.log("\nDPNR Productions - Received message from " + topic + " topic at " + new Date().toLocaleString())
            // console.log("DPNR Productions - The message was " + message.toString());

            message = JSON.parse(message.toString());

            if (message.status === 1) {
                this.mode = 'auto'
            } else {
                this.mode = 'semi-auto'
            }
        },

        /**
         * Listen for LT104, LT105 for ENR or DPNR
         */
        'lgm/data/ENR_DPNR/status'(message, topic) {
            // console.log("\nENR25 Productions - Received message from " + topic + " topic at " + new Date().toLocaleString()
            //     + "\n" + message.toString());

            message = JSON.parse(message.toString());
            // status: 0 DPNR
            // status: 1 ENR
            message.status === 1 ? this.enrSwitchStatus = true : this.enrSwitchStatus = false
        },

        /**
         * Listen for prod batch data.
         * The data contain which process currently active.
         * From this data, system can know whether which process can start and already running.
         *
         * @param message
         * @param topic
         */
        'lgm/batch/prod'(message, topic) {
            // console.log("\nDPNR Productions - Received message from " + topic + " topic at " + new Date().toLocaleString())
            // console.log("DPNR Productions - The message was " + message.toString());

            if (message.toString()) {
                message = JSON.parse(message.toString());

                if (message && !this.checkObjectEmpty(message) && message.product === 'DPNR') {
                    this.batch = message;

                    this.getNextProcess(message);
                    
                } else {
                    this.batch = {}
                }
            }
        },
    },
    mounted() {
        this.getParameters();

        this.$mqtt.subscribe(this.topics, function (err, granted) {
            if (err) {
                console.log("DPNR Productions - Error During Subscription :" + err);
            } else {
                console.log("DPNR Productions - No Error During Subscription");
            }
            if (granted !== undefined) {
                granted.forEach(function (grant) {
                    console.log("DPNR Productions - Subscribed to topic " + grant.topic);
                })
            }
        });

        this.automationService.getCurrentBatchByStage('prod').then((result) => {
            if (typeof result.response !== 'undefined') {
                this.displayErrorPopup(result);
                return;
            }

            this.batch = result.data.data

            if (result.data.data && !this.checkObjectEmpty(result.data.data) && result.data.data.product === 'ENR-25') {
                this.getNextProcess(result.data.data);
            }
        });        

        this.getLatexChart();
        this.getParameters();
    },
    beforeDestroy() {
        // Unsubscribe MQTT topic when component being destroy.
        if (this.topics.length > 0) {
            this.$mqtt.unsubscribe(this.topics);
        }
    }
};
</script>

<style lang="scss" scoped>
@import "../../../assets/styles/pages/productions/dpnr.scss";
</style>
